package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.RksTemplate;
import com.iconplus.smartproc.model.projection.RksTemplateView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface RksTemplateRepository extends JpaRepository<RksTemplate, Long> {

    Optional<RksTemplate> findByKodeTemplateAndIsDeleteFalse(String kodeTemplate);

    @Query(value = "SELECT rt.id as id, " +
            "rt.kode_template as kodeTemplate, " +
            "rt.namaTemplate as namaTemplate, " +
            "rt.metode_pengadaan_id as metodePengadaanId, " +
            "m.metode_pengadaan as metodePengadaan, " +
            "rt.versi as versi, " +
            "rt.rks_daftar_isi_id as rksDaftarIsiId, " +
            "rdi.nama_template as daftarIsi, " +
            "rt.is_active as isActive " +
            "FROM rks_template as rt " +
            "JOIN rks_daftar_isi rdi ON rdi.id = rt.rks_daftar_isi_id " +
            "JOIN metode_pengadaan m ON m.id = rt.metode_pengadaan_id " +
            "WHERE rt.is_delete = 0", nativeQuery = true)
    Page<RksTemplateView> getListRksTemplate(Pageable pageable);

}
