package com.iconplus.smartproc.service.approval;

import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.entity.DrpApproval;
import com.iconplus.smartproc.model.projection.DrpApprovalHistoryView;
import com.iconplus.smartproc.model.projection.DrpApprovalView;
import com.iconplus.smartproc.model.request.DrpApprovalRequest;
import com.iconplus.smartproc.model.response.DrpApprovalHistoryResponse;
import com.iconplus.smartproc.model.response.DrpApprovalResponse;
import com.iconplus.smartproc.model.response.GetListDrpApprovalHistoryResponse;
import com.iconplus.smartproc.model.response.GetListDrpApprovalResponse;
import com.iconplus.smartproc.repository.DrpApprovalHistoryRepository;
import com.iconplus.smartproc.repository.DrpApprovalRepository;
import org.apache.commons.lang3.BooleanUtils;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

@Service
public class GetHistoryApprovalService implements BaseService<DrpApprovalRequest, GetListDrpApprovalHistoryResponse> {

    private final DrpApprovalRepository drpApprovalRepository;
    private final DrpApprovalHistoryRepository drpApprovalHistoryRepository;
    public GetHistoryApprovalService(DrpApprovalRepository drpApprovalRepository,
                                     DrpApprovalHistoryRepository drpApprovalHistoryRepository) {
        this.drpApprovalRepository = drpApprovalRepository;
        this.drpApprovalHistoryRepository = drpApprovalHistoryRepository;

    }


    @Override
    public GetListDrpApprovalHistoryResponse execute(DrpApprovalRequest input) {

        List<DrpApprovalHistoryResponse> drpApprovalHistoryResponses = new ArrayList<>();
        var drpApprovalHistoryViewList = drpApprovalHistoryRepository.getRiwayatApprovalByDrpId(input.getDrpId());
        for (DrpApprovalHistoryView drpApprovalHistoryView : drpApprovalHistoryViewList) {
            DrpApprovalHistoryResponse drpApprovalHistoryResponse = DrpApprovalHistoryResponse.builder()
                    .nama(drpApprovalHistoryView.getNama())
                    .jabatan(drpApprovalHistoryView.getJabatan())
                    .status(drpApprovalHistoryView.getStatus())
                    .date(drpApprovalHistoryView.getDate())
                    .catatan(drpApprovalHistoryView.getCatatan())
                    .build();
            drpApprovalHistoryResponses.add(drpApprovalHistoryResponse);
        }


        return GetListDrpApprovalHistoryResponse.builder()
                .data(drpApprovalHistoryResponses)
                .build();
    }
}
