package com.iconplus.smartproc.service.approval;

import com.iconplus.smartproc.helper.model.EmptyRequest;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.projection.UserRoleView;
import com.iconplus.smartproc.model.response.GetListUserApprovalResponse;
import com.iconplus.smartproc.model.response.UserApprovalResponse;
import com.iconplus.smartproc.repository.UsersRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class GetListUserVpService implements BaseService<EmptyRequest, GetListUserApprovalResponse> {

    private UsersRepository usersRepository;
    public GetListUserVpService(UsersRepository usersRepository) {
        this.usersRepository = usersRepository;
    }

    @Override
    public GetListUserApprovalResponse execute(EmptyRequest input) {

        List<UserApprovalResponse> userApprovalResponseList = new ArrayList<>();

        var userRoleViews = usersRepository.getListUserJabatan(Constants.JABATAN_VP);
        for (UserRoleView userRoleView : userRoleViews) {
            UserApprovalResponse userApprovalResponse = UserApprovalResponse.builder()
                    .id(userRoleView.getId())
                    .nama(userRoleView.getNama() + "-" + userRoleView.getJabatan())
                    .build();
            userApprovalResponseList.add(userApprovalResponse);
        }

        return GetListUserApprovalResponse.builder()
                .data(userApprovalResponseList)
                .build();
    }
}
